<?php

class WPLMS_Front_End_Fields {
	var $course_id;

	var $course_settings;
	var $course_product;

	var $prefix = 'vibe_';
	var $status;

	public static $instance;
    
    public static function init(){
    	wp_deregister_script( 'select2');
    	wp_deregister_style( 'select2');
        if ( is_null( self::$instance ) )
            self::$instance = new WPLMS_Front_End_Fields;
        return self::$instance;
    }

	private function __construct(){
		$this->get();
		add_action('wplms_front_end_pricing_content',array($this,'pmpro_levels'),10,1);
		add_filter('wplms_course_creation_tabs',array($this,'active_components_check'),100);
		add_filter('wplms_course_creation_tabs',array($this,'course_pricing_models'));
		wplms_front_end_loadscripts();
	}

	function get(){
		$this->course_settings = vibe_meta_box_arrays('course');
		$this->course_product = vibe_meta_box_arrays('course_product');
		wplms_front_end_loadscripts();
		wp_enqueue_script( 'timepicker_box', VIBE_PLUGIN_URL . '/vibe-customtypes/metaboxes/js/jquery.timePicker.min.js', array( 'jquery' ) );
		if(isset($this->course_id) && is_numeric($this->course_id)){
            $this->status = get_post_status($this->course_id);
        }
	}
	function pmpro_levels($course_id = null){
		if ( in_array( 'paid-memberships-pro/paid-memberships-pro.php', apply_filters( 'active_plugins', get_option( 'active_plugins' ) ) ) && function_exists('pmpro_getAllLevels')) { 
          $levels=pmpro_getAllLevels(); // Get all the PMPro Levels
          ?>
          <li class="course_membership"><strong><?php _e('Set Course Memberships','vibe'); ?><span>
                  <select id="vibe_pmpro_membership" class="chosen" multiple>
                      <?php
                      if(isset($levels) && is_array($levels)){
                          foreach($levels as $level){
                              if(!is_Array($course_pricing['vibe_pmpro_membership']))
                                  $course_pricing['vibe_pmpro_membership'] = array();
                              
                          if(is_object($level))
                              echo '<option value="'.$level->id.'" '.(in_array($level->id,$course_pricing['vibe_pmpro_membership'])?'selected':'').'>'.$level->name.'</option>';
                          }
                      }
                      ?>
                  </select>
              </span>
              </strong>
          </li>
      <?php    
      }
	}
	function tabs(){
		$course_duration_parameter = apply_filters('vibe_course_duration_parameter',86400);
		$drip_duration_parameter = apply_filters('vibe_drip_duration_parameter',86400);
		$unit_duration_parameter = apply_filters('vibe_unit_duration_parameter',60);
		$quiz_duration_parameter = apply_filters('vibe_quiz_duration_parameter',60);
		$product_duration_parameter = apply_filters('vibe_product_duration_parameter',86400);
		$assignment_duration_parameter = apply_filters('vibe_assignment_duration_parameter',86400);
		return apply_filters('wplms_course_creation_tabs',array(
			'create_course'=>array(
					'icon'=> 'book-open',
					'title'=> (isset($this->course_id)?__('EDIT COURSE','vibe'):__('CREATE COURSE','vibe')),
					'subtitle'=>  __('Start building a course','vibe'),
					'fields'=> array(
						array(
							'label'=> __('Course title','vibe'),
							'type'=> 'title',
							'id' => 'post_title',
							'from'=>'post',
							'value_type'=>'single',
							'style'=>'col-md-12',
							'default'=> __('ENTER A COURSE TITLE','vibe'),
							'help'=> __('This is the title of the course which is displayed on top of every course','vibe')
							),
						array(
							'label'=> __('Course Category','vibe'),
							'type'=> 'taxonomy',
							'taxonomy'=> 'course-cat',
							'from'=>'taxonomy',
							'value_type'=>'single',
							'style'=>'col-md-12',
							'id' => 'course-cat',
							'default'=> __('Select a Course Category','vibe'),
							),
						array(
							'label'=> __('Course Image','vibe'),
							'type'=> 'featured_image',
							'level'=>'thumbnail',
							'value_type'=>'single',
							'upload_title'=>__('Upload a Course Image','vibe'),
							'upload_button'=>__('Set as Course Image','vibe'),
							'style'=>'col-md-3',
							'from'=>'post',
							'id' => 'post_thumbnail',
							'default'=> VIBE_URL.'/images/add_image.png',
							),
						array(
							'label'=> __('Course Short Description','vibe'),
							'type'=> 'textarea',
							'style'=>'col-md-9',
							'value_type'=>'single',
							'id' => 'post_excerpt',
							'from'=>'post',
							'extras' => '<a class="link toggle_vibe_post_content">'.__('Add full description','wplms-front-end').'</a>',
							'default'=> __('Enter a short description of the course.','vibe'),
							),
						array(
							'label'=> __('Full Description','vibe'),
							'type'=> 'editor',
							'style'=>'col-md-12',
							'value_type'=>'single',
							'id' => 'post_content',
							'from'=>'post',
							'default'=> __('Enter full description of the course.','vibe'),
							),
						array(
							'label'=>(isset($this->course_id)?__('SAVE COURSE','vibe'):__('CREATE COURSE','vibe')),
							'id'=>(isset($this->course_id)?'save_course_button':'create_course_button'),
							'type'=>'button'
							),
						),
				),
			'course_settings'=>array(
					'icon'=> 'settings-1',
					'title'=> __('SETTINGS','vibe'),
					'subtitle'=>  __('Course settings','vibe'),
					'fields'=>array(
						array(
							'label'=> __('Course duration','vibe'),
							'text'=>__('Maximum Course Duration','vibe'),
							'type'=> 'number',
							'style'=>'',
							'id' => 'vibe_duration',
							'from'=> 'meta',
							'extra' => calculate_duration_time($course_duration_parameter),
							'default'=>9999,
							'desc'=> sprintf(__('Enter the maximum duration for the course in %s. This is the maximum duration within which the student should complete the course. Use 9999 for unlimited access to course.','vibe'),calculate_duration_time($course_duration_parameter)),
							),
						array(
							'label'=> __('Course Evaluation','vibe'),
							'text'=>__('Course Evaluation Mode','vibe'),
							'type'=> 'switch',
							'options'  => array('H'=>__('MANUAL','vibe'),'S'=>__('AUTOMATIC','vibe')),
							'style'=>'',
							'id' => 'vibe_course_auto_eval',
							'from'=> 'meta',
							'default'=>'H',
							'desc'=> __('User gets the course result instantly upon submission.','vibe')
							),
						array(
							'label'=> __('Prerequisite Course','vibe'),
							'text'=>__('Set a prerequisite Course','vibe'),
							'type'=> 'selectmulticpt',
							'cpt'=> 'course',
							'style'=>'',
							'id' => 'vibe_pre_course',
							'placeholder'=> __('Enter first 4 letters of course for search','vibe'),
							'from'=> 'meta',
							'desc'=> __('Pre-required course which the user needs to complete before subscribing to this course.','vibe'),
							),
						array(
							'label'=> __('Drip Feed','vibe'),
							'text'=>__('Course Drip Feed','vibe'),
							'type'=> 'conditionalswitch',
							'hide_nodes'=> array('vibe_course_section_drip','vibe_course_drip_duration'),
							'options'  => array('H'=>__('DISABLE','vibe'),'S'=>__('ENABLE','vibe')),
							'style'=>'',
							'id' => 'vibe_course_drip',
							'from'=> 'meta',
							'default'=>'H',
							'desc'=> __('Drip Feed courses, units are released one by one after certain duration to the user.','vibe'),
							),
						array(
							'label'=> __('Drip Feed Type','vibe'),
							'text'=>__('Drip Feed Type','vibe'),
							'type'=> 'switch',
							'options'  => array('H'=>__('UNIT','vibe'),'S'=>__('SECTION','vibe')),
							'style'=>'',
							'id' => 'vibe_course_section_drip',
							'from'=> 'meta',
							'default'=>'H',
							'desc'=> __('Drip Feed courses, units are released one by one after certain duration to the user.','vibe')
							),
						array(
							'label'=> __('Drip Duration','vibe'),
							'text'=>__('Set Duration between two successive Course elements','vibe'),
							'type'=> 'number',
							'style'=>'',
							'id' => 'vibe_course_drip_duration',
							'from'=> 'meta',
							'extra' => calculate_duration_time($drip_duration_parameter),
							'default'=>1,
							'desc'=> sprintf(__('Enter the drip duration for the course in %s. This is the duration after which the next unit/section unlocks for the user after viewing the previous unit/section.','vibe'),calculate_duration_time($drip_duration_parameter)),
							),
						array(
							'label'=> __('Course Certificate','vibe'),
							'text'=>__('Course Certificate','vibe'),
							'type'=> 'conditionalswitch',
							'hide_nodes'=> array('vibe_course_passing_percentage','vibe_certificate_template'),
							'options'  => array('H'=>__('DISABLE','vibe'),'S'=>__('ENABLE','vibe')),
							'style'=>'',
							'id' => 'vibe_course_certificate',
							'from'=> 'meta',
							'default'=>'H',
							'desc'=> __('Drip Feed courses, units are released one by one after certain duration to the user.','vibe'),
							),
						array(
							'label'=> __('Passing Percentage','vibe'),
							'text'=>__('Set Certificate Percentage','vibe'),
							'type'=> 'number',
							'style'=>'',
							'id' => 'vibe_course_passing_percentage',
							'from'=> 'meta',
							'extra' => __(' out of 100','vibe'),
							'default'=> 40,
							'desc'=> __('Any user achieving more marks (weighted average of Quizzes/assignments in course) than this gets the Course certificate.','vibe'),
							),
						array(
							'label'=> __('Certificate Template','vibe'),
							'text'=>__('Select Certificate template','vibe'),
							'type'=> 'selectcpt',
							'cpt'=> 'certificate',
							'style'=>'',
							'id' => 'vibe_certificate_template',
							'placeholder'=> __('Enter first 3 letters to search course template','vibe'),
							'from'=> 'meta',
							'desc'=> __('Pre-required course which the user needs to complete before subscribing to this course.','vibe'),
							),
						array(
							'label'=> __('Course Badge','vibe'),
							'text'=>__('Course Badge','vibe'),
							'type'=> 'conditionalswitch',
							'hide_nodes'=> array('vibe_course_badge_percentage','vibe_course_badge_title','vibe_course_badge'),
							'options'  => array('H'=>__('DISABLE','vibe'),'S'=>__('ENABLE','vibe')),
							'style'=>'',
							'id' => 'vibe_badge',
							'from'=> 'meta',
							'default'=>'H',
							'desc'=> __('Enable Excellence badges for this course','vibe'),
							),
						array(
							'label'=> __('Badge Percentage','vibe'),
							'text'=>__('Set Excellence Badge Percentage','vibe'),
							'type'=> 'number',
							'style'=>'',
							'id' => 'vibe_course_badge_percentage',
							'from'=> 'meta',
							'extra' => __(' out of 100','vibe'),
							'default'=>75,
							'desc'=> __('Any user achieving more marks (weighted average of Quizzes/assignments in course) than this gets the Course Badge.','vibe'),
							),
						array(
							'label'=> __('Badge Title','vibe'),
							'text'=>__('Set Badge title','vibe'),
							'type'=> 'text',
							'style'=>'',
							'id' => 'vibe_course_badge_title',
							'from'=> 'meta',
							'default'=>__('Course Badge Title','vibe'),
							'desc'=> __('Course Badge Title','vibe'),
							),
						array(
							'label'=> __('Course Badge','vibe'),
							'text'=>__('Upload Course Badge','vibe'),
							'type'=> 'media',
							'style'=>'',
							'title'=>__('Select or Upload a Course badge.','vibe'),
							'button'=>__('Add Course badge.','vibe'),
							'id' => 'vibe_course_badge',
							'default'=> VIBE_URL.'/images/add_image.png',
							'from'=> 'meta',
							'desc'=> __('Upload a course badge.','vibe'),
							),
						array(
							'label'=> __('Course Start Date','vibe'),
							'text'=>__('Start date','vibe'),
							'type'=> 'date',
							'style'=>'',
							'id' => 'vibe_start_date',
							'default'=> the_date('Y-m-d','','',false),
							'from'=> 'meta',
							'desc'=> __('Set a Course start date.','vibe'),
							),
						array(
							'label'=> __('Course Instructions','vibe'),
							'text'=>__('Add Course specific instructions','vibe'),
							'type'=> 'editor',
							'style'=>'',
							'id' => 'vibe_course_instructions',
							'from'=> 'meta',
							'desc'=> __('Course instructions are displayed when the user starts a course.','vibe'),
							),
						array(
							'label'=> __('Course Completion Message','vibe'),
							'text'=>__('Completion Message','vibe'),
							'type'=> 'editor',
							'style'=>'',
							'id' => 'vibe_course_message',
							'from'=> 'meta',
							'desc'=> __('Completion message is shown to the student when she finishes the course.','vibe'),
							),
						array(
							'label'=>__('SAVE SETTINGS','vibe'),
							'id'=>'save_course_settings_button',
							'type'=>'button'
							),
					),
				),
			'course_components'=>array(
					'icon'=> 'archive',
					'title'=> __('COMPONENTS','vibe'),
					'subtitle'=>  __('Course settings','vibe'),
					'fields'=>array(
						array(
							'label'=> __('Course Group','vibe'),
							'text'=>__('Set a Course Group','vibe'),
							'type'=> 'group',
							'style'=>'',
							'id' => 'vibe_group',
							'from'=> 'meta',
							'desc'=> __('Upload a course badge.','vibe'),
							),
						array(
							'label'=> __('Course Forum','vibe'),
							'text'=>__('Set a Course Forum','vibe'),
							'type'=> 'forum',
							'style'=>'',
							'id' => 'vibe_forum',
							'from'=> 'meta',
							'desc'=> __('Upload a course badge.','vibe'),
							),
						array(
							'label'=>__('SAVE COMPONENTS','vibe'),
							'id'=>'save_course_components_button',
							'type'=>'button'
							),
						)
					),
			'course_curriculum'=>array(
					'icon'=> 'file',
					'title'=> __('SET CURRICULUM','vibe'),
					'subtitle'=>  __('Add Units and Quizzes','vibe'),
					'fields'=>array(
						array(
							'label'=>__('Curriculum'),
							'id'=>'vibe_course_curriculum',
							'buttons'=> array('add_course_section'=>__('ADD SECTION','vibe'),'add_course_unit'=>__('ADD UNIT','vibe'),'add_course_quiz'=>__('ADD QUIZ','vibe')),
							'type'=> 'curriculum',
							'style'=>'',
							'default'=>9999,
							'desc'=> __('Build Course curriculum','vibe'),
							),
						),
				),
			'course_pricing' => array(
					'icon'=> 'tag',
					'title'=>  __('PRICING','vibe'),
					'subtitle'=>  __('Set Price for Course','vibe'),
					'fields'=>array(
						array(
							'label'=> __('Course Pricing','vibe'),
							'type'=> 'heading',
							),
						array(
							'label'=> __('Free ','vibe'),
							'text'=>__('Free Course','vibe'),
							'type'=> 'switch',
							'options'  => array('H'=>__('No','vibe'),'S'=>__('Yes','vibe')),
							'style'=>'',
							'id' => 'vibe_course_free',
							'from'=> 'meta',
							'default'=>'H',
							'desc'=> __('By pass any purchase process.','vibe')
							),
						array(
							'label'=> __('Product ','vibe'),
							'text'=>__('Set a Course Product','vibe'),
							'cpt'=>'product',
							'type'=> 'selectproduct',
							'style'=>'',
							'id' => 'vibe_product',
							'from'=> 'meta',
							'default'=>'',
							'desc'=> __('Connect a Product with this course.','vibe')
							),
						array(
							'label'=>__('SAVE PRICING','vibe'),
							'id'=>'save_pricing_button',
							'type'=>'button'
							),
						),
				),
			'course_live'=>array(
					'icon'=> 'glass',
					'title'=> (($this->status == 'publish')?__('MODIFY COURSE','vibe'):__('PUBLISH COURSE','vibe')),
					'subtitle'=>  (($this->status == 'publish')?__('Change Course status','vibe'):__('Go Live !','vibe')),
					'fields'=>array(
						array(
							'label'=> __('Take Offline','vibe'),
							'id'=>'offline_course',
							'type'=> 'course_live',
							),
						),
				)
			));
	}

	function settings(){
		foreach($this->course_settings as $key => $value){
			$this->generate_fields($value);
		}
	}
	function prepopulate(){

		if(is_numeric($this->course_id)){
			
		    $course_cats =wp_get_post_terms( $this->course_id, 'course-cat');
		    $course_cats[0]->term_id;

		    if(isset($linkage ) && $linkage ){
		        wp_get_post_terms( $this->course_id, 'linkage',array("fields" => "names"));
		    } 
		}
	}

	function create_tabs(){
		?>
		<div class="col-md-3 col-sm-4">
			<div id="course_creation_tabs" class="course-create-steps">
	            <ul <?php echo ((isset($this->course_id))?'class="islive"':'');?>>
	            	<?php
	            		$tabs = $this->tabs();
	            		foreach($tabs as $key => $tab){
	            			echo '<li class="'.$key.' '.(($key == 'create_course')?'active':'').'"><i class="icon-'.$tab['icon'].'"></i><a href="#'.$key.'">  '.$tab['title'].'<span>'.$tab['subtitle'].'</span></a></li>';
	            		}
	            	?>
	            </ul>
	        </div>
		<?php
		if(is_numeric($this->course_id)){

		$extras = apply_filters('wplms_front_end_course_extras',array(
			array(
				'label'=> '<i class="icon-send-to-back"></i>',
				'title' => __('Edit in WP Admin','wplms-front-end'),
				'link' => get_edit_post_link($this->course_id),
				),
			array(
				'label'=> '<i class="icon-eye"></i>',
				'title' => __('View Course','wplms-front-end'),
				'link' => get_permalink($this->course_id)
				)
			));
			 echo '<ul class="course_extras">';
			foreach($extras as $extra){
				echo '<li><a href="'.$extra['link'].'" title="'.$extra['title'].'">'.$extra['label'].'</a></li>';
			}
			echo '</ul>';
		}
		?>
		</div>
		<?php
	}

	function course_tab_module(){
		$tabs = $this->tabs();
		?>
		<div class="col-md-9 col-sm-8">   
            <div class="edit_course_content content">
            	<?php
            		foreach($tabs as $key => $tab){
            			echo '<div id="'.$key.'" '.(($key == 'create_course')?'class="active"':'').'>';
            			if(isset($tab['fields']) && is_array($tab['fields']) && count($tab['fields'])){
            				echo '<article><ul class="'.$key.'">';
            				foreach($tab['fields'] as $field){
            					echo '<li class="vibe_'.$field['id'].'">';
            					$this->generate_fields($field);
            					echo '</li>';
            				}
            				echo '</ul></article>';
            			}
            			echo '</div>';
            		}
            		wp_nonce_field('security','security');
            		echo '<input type="hidden" id="course_id" value="'.((get_post_type($_GET['action']) == 'course')?$_GET['action']:'').'" />';
            	?>
            </div>
        </div>
		<?php
	}

	function course_pricing_models($settings){
		$product_settings = vibe_meta_box_arrays('course_product');
		unset($product_settings['vibe_course_free']);
		unset($product_settings['vibe_product']);
		foreach($product_settings as $key => $prd_set ){
			$product_settings[$key]['text']=$product_settings[$key]['label'];
		}
		array_splice($settings['course_pricing']['fields'],3,0,$product_settings);
		return $settings;
	}
	function generate_fields($field,$id = null){

		if(!empty($id)){
			$this->course_id = $id;
		}

		$user_id=get_current_user_id();
		if(!empty($this->course_id)){
			switch($field['from']){
				case 'post':
					$field['value'] = get_post_field($field['id'],$this->course_id);
				break;
				case 'taxonomy':
					$terms	= wp_get_post_terms($this->course_id,$field['taxonomy']);
					if(!empty($terms)){
						$field['value'] = $terms[0]->term_id;
					}
				break;
				default:
					if($field['value_type'] == 'array'){
						$single = false;
					}else{
						$single = true;
					}
					$field['value'] = get_post_meta($this->course_id,$field['id'],$single);
				break;
			}
		}else{
			$field['value'] = $field['default'];
		}
		
		switch($field['type']){
			case 'heading':
				echo '<strong>'.$field['label'].'</strong>';
			break;
			case 'number': 
				echo '<div class="field_wrapper '. $field['style'].'">
					   <label>'. $field['label'].(empty($field['desc'])?'':'<a class="tip" title="'.$field['desc'].'"><i class="icon-question"></i></a>').'</label>'.(!empty($field['text'])?'<strong>'.$field['text'].'</strong>':''); 
				echo (!empty($field['text'])?'<div class="right">':'').'<input type="number" id="" class="small_box post_field '.(empty($field['text'])?'form_field':'').'" data-id="'.$field['id'].'" data-type="'.$field['type'].'" placeholder="'.$field['default'].'" value="'.$field['value'].'"/>'.(isset($field['extra'])?$field['extra']:'').'</div>';
				echo   (!empty($field['text'])?'</div>':'');
			break;
			case 'text':
				echo   '<div class="field_wrapper '. $field['style'].'">';
				echo   '<label>'. $field['label'].(empty($field['desc'])?'':'<a class="tip" title="'.$field['desc'].'"><i class="icon-question"></i></a>').'</label>';
				echo   (!empty($field['text'])?'<strong>'.$field['text'].'</strong>':''); 
				echo   '<input type="text" placeholder="'.$field['default'].'" data-id="'.$field['id'].'" data-type="'.$field['type'].'" class="mid_box post_field '.(empty($field['text'])?'form_field':'').'" value="'.$field['value'].'"/>'.(isset($field['extra'])?$field['extra']:'');
				echo   '</div>';
			break;
			case 'title':
				echo '<div class="field_wrapper '. $field['style'].'">';
				echo '<label>'. $field['label'].(empty($field['desc'])?'':'<a class="tip" title="'.$field['desc'].'"><i class="icon-question"></i></a>').'</label>';
				echo '<input type="text"  class="megatext post_field" data-id="'.$field['id'].'" data-type="'.$field['type'].'" placeholder="'.$field['default'].'" value="'.(($field['default'] != $field['value'])?$field['value']:'').'" />';
				echo   '</div>';
				echo '<hr />';
			break;
			case 'taxonomy':
			echo '<div class="field_wrapper '. $field['style'].'">';
				echo '<label>'. $field['label'].(empty($field['desc'])?'':'<a class="tip" title="'.$field['desc'].'"><i class="icon-question"></i></a>').'</label>';
				?>
				<ul id="<?php echo $field['id']; ?>" class="wplms-taxonomy">
                    <li>
                        <select id="<?php echo $field['id']; ?>-select" class="chosen post_field" <?php echo 'data-id="'.$field['id'].'" data-taxonomy="'.$field['taxonomy'].'" data-type="'.$field['type'].'"'; ?>>
                            <option><?php echo $field['default']; ?></option>
                            <option value="new"><?php _e('Add new','vibe'); ?></option>
                            <?php
                            $terms = get_terms($field['taxonomy'],array('hide_empty' => false,'orderby'=>'name','order'=>'ASC'));
                            if(isset($terms) && is_array($terms))
                            foreach($terms as $term){
                                $parenttermname='';
                                if($term->parent){
                                    $parentterm=get_term_by('id', $term->parent, $field['taxonomy'], 'ARRAY_A');
                                    $parenttermname = $parentterm['name'].' &rsaquo; ';
                                }
                                echo '<option value="'.$term->term_id.'" '.(isset($_GET['action'])?selected($field['value'],$term->term_id):'').'>'.$parenttermname.$term->name.'</option>';
                            }
                            ?>
                        </select>
                    </li>
                    <li><input type="text" id="new_<?php echo str_replace('-','_',$field['id']); ?>" class="ccf_text post_field wplms-new-taxonomy" <?php echo 'data-id="'.$field['taxonomy'].'" data-type="'.$field['type'].'_new"'; ?> placeholder="<?php _e('Enter a new','vibe'); ?>" /></li>
                </ul><br />
				<?php
				echo   '</div>';
				echo '<hr />';
			break;
			case 'featured_image':
			echo '<div class="field_wrapper '. $field['style'].'">';
				echo '<label>'. $field['label'].(empty($field['desc'])?'':'<a class="tip" title="'.$field['desc'].'"><i class="icon-question"></i></a>').'</label>';
                 ?>      
                <div id="<?php echo $field['id']; ?>" class="upload_image_button" data-input-name="<?php echo $field['id']; ?>" data-uploader-title="<?php echo $field['upload_title'];?>" data-uploader-button-text="<?php echo $field['upload_button'];?>" data-uploader-allow-multiple="false">
                    <?php 
                    if(isset($this->course_id) && has_post_thumbnail($this->course_id )){
                    	if($field['level'] == 'thumbnail'){
                    		echo get_the_post_thumbnail($this->course_id,'thumbnail');
                    		echo '<input type="hidden" value="'.get_post_thumbnail_id($this->course_id).'" class="post_field" data-id="'.$field['id'].'" data-type="'.$field['type'].'" />';
                    	}
                    }else{
                    ?>
                    <img src="<?php echo $field['default']; ?>" alt="course image" class="default" />
                    <?php
                    }
                    ?>
                </div>
                <?php
            echo   '</div>';    
			break;
			case 'media':
				echo '<div class="field_wrapper '. $field['style'].'">';
				echo '<label>'. $field['label'].(empty($field['desc'])?'':'<a class="tip" title="'.$field['desc'].'"><i class="icon-question"></i></a>').'</label>';
				echo (empty($field['text'])?'':'<strong>'.$field['text'].'</strong>').'
					<div class="upload_button">';
				if(is_numeric($field['value']))	{
					$attachment = wp_get_attachment_image_src($field['value']);
					if(empty($attachment)){
						echo '<a id="'.$field['id'].'" data-input-name="'.$field['id'].'" data-uploader-title="'.$field['title'].'" data-uploader-button-text="'.$field['button'].'"><i class="icon-image-photo-file-1"></i></a>';
					}else{
						$url = $attachment[0];	
						echo '<a id="'.$field['id'].'" data-input-name="'.$field['id'].'" data-uploader-title="'.$field['title'].'" data-uploader-button-text="'.$field['button'].'"><img src="'.$url.'" class="submission_thumb thumbnail" /><input type="hidden" value="'.$field['value'].'" data-id="'.$field['id'].'" data-type="'.$field['type'].'" /></a>';
					}
				}else{
					echo '<a id="'.$field['id'].'" data-input-name="'.$field['id'].'" data-uploader-title="'.$field['title'].'" data-uploader-button-text="'.$field['button'].'"><i class="icon-image-photo-file-1"></i></a>';
				}
				echo '<script>
					var media_uploader'.$field['id'].';
					jQuery("#'.$field['id'].'").on("click", function( event ){
					  
					    var button = jQuery( this );
					    if ( media_uploader'.$field['id'].' ) {
					      media_uploader'.$field['id'].'.open();
					      return;
					    }
					    // Create the media uploader.
					    media_uploader'.$field['id'].' = wp.media.frames.media_uploader'.$field['id'].' = wp.media({
					        title: button.attr( "data-uploader-title"),
					        library: {
					            type: "image",
					            query: false
					        },
					        button: {
					            text: button.attr("data-uploader-button-text"),
					        },
					    });

					    // Create a callback when the uploader is called
					    media_uploader'.$field['id'].'.on( "select", function() {
					        var selection = media_uploader'.$field['id'].'.state().get("selection"),
					            input_name = button.data( "input-name");
					            selection.map( function( attachment ) {
					            	attachment = attachment.toJSON(); console.log(attachment);
					            	button.html("<img src=\'"+attachment.url+"\' class=\'submission_thumb thumbnail\' /><input id=\'"+input_name +"\' class=\'form-control post_field\' name=\'"+input_name+"\' data-id=\''.$field['id'].'\' data-type=\''.$field['type'].'\' type=\'hidden\' value=\'"+attachment.id+"\' />");
					         	});
					    });
					    // Open the uploader
					    media_uploader'.$field['id'].'.open();
					  });
				</script>
				</div>';
			break;
			case 'textarea':
			echo '<div class="field_wrapper '. $field['style'].'">';
				echo '<label>'. $field['label'].(empty($field['desc'])?'':'<a class="tip" title="'.$field['desc'].'"><i class="icon-question"></i></a>').'</label>';
				echo '<textarea id="'.$field['id'].'" class="post_field" data-id="'.$field['id'].'" data-type="'.$field['type'].'">'. $field['value'].'</textarea>'.(empty($field['extras'])?'':$field['extras']);
			echo   '</div>';	
			break;
			case 'editor':
				echo '<div class="field_wrapper '. $field['style'].'">';
				echo '<label>'. $field['label'].'</label>';
				wp_editor($field['value'],$field['id']);
				echo   '</div>';
			break;
			case 'date':
			case 'calendar':
				echo '<div class="field_wrapper '. $field['style'].'">';
				echo '<label>'. $field['label'].(empty($field['desc'])?'':'<a class="tip" title="'.$field['desc'].'"><i class="icon-question"></i></a>').'</label>';
				echo (!empty($field['text'])?'<strong>'.$field['text'].'</strong><div class="right">':''); 
				echo '<input type="text" placeholder="'.$field['default'].'" value="'.$field['value'].'" data-id="'.$field['id'].'" class="mid_box date_box post_field '.(empty($field['text'])?'form_field':'').'" data-id="'.$field['id'].'" data-type="'.$field['type'].'"/>';
				echo (!empty($field['text'])?'</div>':'');
				echo   '<script>jQuery(document).ready(function(){
						jQuery( ".date_box" ).datepicker({
		                    dateFormat: "yy-mm-dd",
		                    numberOfMonths: 1,
		                    showButtonPanel: true,
		                });});</script><style>.ui-datepicker{z-index:99;}</style></div>';
			break;
			case 'time':
				echo '<div class="field_wrapper '. $field['style'].'">';
				echo '<label>'. $field['label'].(empty($field['desc'])?'':'<a class="tip" title="'.$field['desc'].'"><i class="icon-question"></i></a>').'</label>';
				echo (!empty($field['text'])?'<strong>'.$field['text'].'</strong><div class="right">':''); 
				echo '<input type="text" placeholder="'.$field['default'].'" value="'.$field['value'].'" data-id="'.$field['id'].'" class="mid_box time_box post_field '.(empty($field['text'])?'form_field':'').'" data-id="'.$field['id'].'" data-type="'.$field['type'].'"/>';
				echo (!empty($field['text'])?'</div>':'');
				echo   '<script>
				jQuery(document).ready(function(){
                 jQuery( ".time_box" ).each(function(){
                 jQuery(this).timePicker({
                      show24Hours: false,
                      separator:":",
                      step: 15
                  });
                });});</script></div>';
			break;
			case 'group':
				echo '<div class="field_wrapper '. $field['style'].'">';
				echo '<label>'. $field['label'].(empty($field['desc'])?'':'<a class="tip" title="'.$field['desc'].'"><i class="icon-question"></i></a>').'</label>';
				?>
				<input type="hidden" id="vibe_group" class="post_field" value="<?php echo $field['value']; ?>" <?php echo 'data-id="'.$field['id'].'" data-type="'.$field['type'].'" '; ?> />
				<?php
				echo '<h3>';
				if(empty($field['value']) || $field['value'] == $field['default']){
					echo '<span>'.$field['text'].'</span>';
					$flag=0;
				}else{
					echo self::get_group_name($field['value']); echo '<span>'.__('edit','vibe').'</span>';
					$flag = 1;
				}
				echo '</h3>'; ?>
				<div id="change_group" <?php echo (($flag)?'style="display:none;"':''); ?>>
					<div class="col-md-6">
						<a class="more"><i class="icon-users"></i> <?php _e('Select Existing Group','vibe'); ?></a>
						<div class="select_group_form">
							<select class="selectgroup" data-placeholder="<?php _e('Select a Group','vibe'); ?>">
							</select>
							<a class="use_selected button"><?php _e('Set','vibe'); ?></a>
						</div>
					</div>
					<div class="col-md-6">
						<a class="more"><i class="icon-user"></i> <?php _e('Create New Group','vibe'); ?></a>
						<div class="new_group_form">
							<input type="text" class="form_field" id="vibe_group_name" name="name" placeholder="<?php _e('Group Name','vibe'); ?>">
							<select id="vibe_group_privacy" class="chosen form_field">
								<option value="public"><?php _e('Public','vibe'); ?></option>
								<option value="private"><?php _e('Private','vibe'); ?></option>
								<option value="hidden"><?php _e('Hidden','vibe'); ?></option>
							</select>
							<textarea class="description" id="vibe_group_description" placeholder="<?php _e('Group Description','vibe'); ?>"></textarea>
							<a class="button small" id="create_new_group"><?php _e('Create New Group','vibe'); ?></a>
						</div>
					</div>
				</div>
               <?php
				echo   '</div>';
			break;
			case 'forum':
				echo '<div class="field_wrapper '. $field['style'].'">';
				echo '<label>'. $field['label'].(empty($field['desc'])?'':'<a class="tip" title="'.$field['desc'].'"><i class="icon-question"></i></a>').'</label>';
				?>
				<input type="hidden" id="vibe_forum" class="post_field" value="<?php echo $field['value']; ?>" <?php echo 'data-id="'.$field['id'].'" data-type="'.$field['type'].'"'; ?> />
				<?php
				echo '<h3>';
				if(empty($field['value']) || $field['value'] == $field['default']){
					echo '<span>'.$field['text'].'</span>';
					$flag=0;
				}else{
					echo get_the_title($field['value']); echo '<span>'.__('edit','vibe').'</span>';
					$flag = 1;
				}
				echo '</h3>'; ?>
				<div id="change_forum" <?php echo (($flag)?'style="display:none;"':''); ?>>
					<div class="col-md-6">
						<a class="more"><i class="icon-users"></i> <?php _e('Select Existing Forum','vibe'); ?></a>
						<div class="select_forum_form">
							<select class="selectforum" data-placeholder="<?php _e('Select a Forum','vibe'); ?>">
							</select>
							<a class="use_selected button"><?php _e('Set','vibe'); ?></a>
						</div>
					</div>
					<div class="col-md-6">
						<a class="more"><i class="icon-user"></i> <?php _e('Create New Forum','vibe'); ?></a>
						<div class="new_forum_form">
							<input type="text" class="form_field" id="vibe_forum_name" name="name" placeholder="<?php _e('Forum Name','vibe'); ?>">
							<select id="vibe_forum_privacy" class="chosen form_field">
								<option value="publish"><?php _e('Public','vibe'); ?></option>
								<option value="private"><?php _e('Private','vibe'); ?></option>
								<option value="hidden"><?php _e('Hidden','vibe'); ?></option>
							</select>
							<textarea class="description" id="vibe_forum_description" placeholder="<?php _e('Forum Description','vibe'); ?>"></textarea>
							<a class="button small" id="create_new_forum"><?php _e('Create New Forum','vibe'); ?></a>
						</div>
					</div>
				</div>
				<?php
			break;
			case 'icon':
			break;
			case 'color':
			break;
			case 'checkbox':
			break;
			case 'yesno':
			case 'showhide':
				echo '<div class="field_wrapper '. $field['style'].'">';
				echo '<label>'.$field['label'].(empty($field['desc'])?'':'<a class="tip" title="'.$field['desc'].'"><i class="icon-question"></i></a>').'</label><strong>'.$field['text'].'</strong><div class="switch">';
				$i=0;
				foreach($field['options'] as $option){
					echo '<input type="radio" class="switch-input post_field '.$field['id'].'" name="'.$field['id'].'" data-id="'.$field['id'].'" data-type="'.$field['type'].'" value="'.$option['value'].'" id="'.$field['id'].$option['value'].'" ';checked($field['value'],$option['value']); echo '>';
	                   echo '<label for="'.$field['id'].$option['value'].'" class="switch-label switch-label-'.(!($i%2)?'off':'on').'">'.$option['label'].'</label>';$i++;
				}
	            echo '<span class="switch-selection"></span></div></div>';
			break;
			case 'switch':
				echo '<div class="field_wrapper '. $field['style'].'">';
				echo '<label>'.$field['label'].'</label><strong>'.$field['text'].'</strong><div class="switch">';
				$i=0;
				if(empty($field['value'])){
					if(empty($field['default'])){
						if(!empty($field['std']))
							$field['value'] = $field['std'];
					}else
						$field['value'] = $field['default'];
				}
				foreach($field['options'] as $key=>$value){
					echo '<input type="radio" class="switch-input post_field '.$field['id'].'" name="'.$field['id'].'" data-id="'.$field['id'].'" data-type="'.$field['type'].'" value="'.$key.'" id="'.$field['id'].$key.'" ';checked($field['value'],$key); echo '>';
	                   echo '<label for="'.$field['id'].$key.'" class="switch-label switch-label-'.(!($i%2)?'off':'on').'">'.$value.'</label>';$i++;
				}
	            echo '<span class="switch-selection"></span></div></div>';
			break;
			case 'conditionalswitch':
				echo '<div class="field_wrapper '. $field['style'].'">';
				echo '<label>'.$field['label'].(empty($field['desc'])?'':'<a class="tip" title="'.$field['desc'].'"><i class="icon-question"></i></a>').'</label><strong>'.$field['text'].'</strong><div class="switch">';
				$i=0;
				if(empty($field['value'])){
					if(empty($field['default'])){
						if(!empty($field['std']))
							$field['value'] = $field['std'];
					}else
						$field['value'] = $field['default'];
				}
				foreach($field['options'] as $key=>$value){
					echo '<input type="radio" data-id="'.$field['id'].'" data-type="'.$field['type'].'" class="switch-input post_field conditional-switch '.$field['id'].'" data-id="'.$field['id'].'" data-type="'.$field['type'].'" name="'.$field['id'].'" value="'.$key.'" id="'.$field['id'].$key.'" ';checked($field['value'],$key); echo '>';
                    echo '<label for="'.$field['id'].$key.'" class="switch-label switch-label-'.(!($i%2)?'off':'on').'">'.$value.'</label>';
                    $i++;
				}
	            echo '<span class="switch-selection"></span></div></div>';
	            if(!empty($field['hide_nodes'])){
	            	echo '<script>
			            jQuery(document).ready(function($){
			            	$(".conditional-switch.'.$field['id'].'").each(function(){	
				            	$(this).on("click",function(){
				            		var val = $(this).parent().find(".conditional-switch.'.$field['id'].':checked").val();
				            		if(val == "S" || val === "S"){';
				            		foreach($field['hide_nodes'] as $node){
				            			echo '$(".vibe_'.$node.'").show(200).addClass("conditional_display");';
					            	}
					        		echo '}else{';
					        				foreach($field['hide_nodes'] as $node){
						            			echo '$(".vibe_'.$node.'").hide(200).removeClass("conditional_display");';
							            	}
									echo '		            	
				            		}
				            	});
								var val = $(this).parent().find(".conditional-switch.'.$field['id'].':checked").val();
			            		if(typeof val !== "undefined" && (val == "S" || val === "S")){';
			            		foreach($field['hide_nodes'] as $node){
			            			echo '$(".vibe_'.$node.'").show(200).addClass("conditional_display");';
				            	}
				        		echo '}else{';
				        				foreach($field['hide_nodes'] as $node){
					            			echo '$(".vibe_'.$node.'").hide(200).removeClass("conditional_display");';
						            	}
								echo '		            	
			            		}
				            });
						});
		            </script>';
		        }    	
			break;
			case 'select':
				echo '<div class="field_wrapper '. $field['style'].'">';
				echo '<label>'.$field['label'].(empty($field['desc'])?'':'<a class="tip" title="'.$field['desc'].'"><i class="icon-question"></i></a>').'</label>'.(!empty($field['text'])?'<strong>'.$field['text'].'</strong>':''); 
				echo '<select class="select2 post_field" style="width: 100%;" data-id="'.$field['id'].'" data-type="'.$field['type'].'" >';
				if(!empty($field['options'])){
					foreach($field['options'] as $option){
						echo '<option value="'.$option['value'].'" '.(($field['value'] == $option['value'])?'selected="selected"':'').'>'.$option['label'].'</option>';
					}
				}
				echo '</select></div>';
			break;
			case 'selectcpt':
				echo '<div class="field_wrapper '. $field['style'].'">';
				echo '<label>'.$field['label'].(empty($field['desc'])?'':'<a class="tip" title="'.$field['desc'].'"><i class="icon-question"></i></a>').'</label>'.(!empty($field['text'])?'<strong>'.$field['text'].'</strong>':''); 
				if(empty($field['post_status'])){
					$field['post_status'] = 'publish';
				}else{
					$field['post_status'] = implode(',',$field['post_status']);
				}
				echo (!empty($field['text'])?'<div class="right">':'').'<select class="select2 selectcpt post_field" data-id="'.$field['id'].'" data-type="'.$field['type'].'" data-status="'.$field['post_status'].'" style="width: 100%;" data-placeholder="'.$field['placeholder'].'" data-cpt="'.(($field['cpt'])?$field['cpt']:(($field['post_type'])?$field['post_type']:'')).'">';
				if(!empty($field['value']) && $field['value'] != $field['default']){
					echo '<option value="'.$field['value'].'">'.get_the_title($field['value']).'</option>';
				}
				echo '</select></div>';
			break;
			case 'selectproduct':

				$product_duration_parameter = apply_filters('vibe_product_duration_parameter',86400); 
									$product_fields= apply_filters('wplms_front_end_new_product',array(
										array(
										'label'=> __('Title','vibe'),
										'placeholder'=>__('Product Title','vibe'),
										'type'=> 'text',
										'style'=>'',
										'from'=>'post',
										'id' => 'post_title',
										'desc'=> __('Product title is useful to identify courses connected to this product.','vibe'),
										),
										array(
										'label'=> __('Price','vibe'),
										'text'=>__('Price','vibe'),
										'type'=> 'text',
										'style' => 'col-md-6',
										'id' => '_regular_price',
										'extra' => get_woocommerce_currency(),
										'desc'=> __('Set price of the course','vibe'),
										),
										array(
										'label'=> __('Sale','vibe'),
										'text'=>__('Sale Price','vibe'),
										'type'=> 'text',
										'style' => 'col-md-6',
										'id' => '_sale_price',
										'extra' => get_woocommerce_currency(),
										'desc'=> __('Blank if product not in sale','vibe'),
										),
										array(
										'label'=> __('Subscription','vibe'),
										'type'=> 'conditionalswitch',
										'text'=>__('Subscription Type','vibe'),
										'hide_nodes'=> array('vibe_duration'),
										'options'  => array('H'=>__('FULL DURATION','vibe'),'S'=>__('LIMITED','vibe')),
										'style'=>'',
										'default'=>'H',
										'id' => 'vibe_subscription',
										'desc'=> __('Set subscription type of product.','vibe'),
										),
										array(
										'label'=> __('Subscription Duration','vibe'),
										'type'=> 'text',
										'style'=>'',
										'id' => 'vibe_duration',
										'extra' => calculate_duration_time($product_duration_parameter),
										'from'=> 'meta',
										'default'=> __('Must not be 0','wplms-front-end'),
										),
									));

				echo '<label>'.$field['label'].(empty($field['desc'])?'':'<a class="tip" title="'.$field['desc'].'"><i class="icon-question"></i></a>').'</label>';
				if(!empty($field['value']) && $field['value'] != $field['default']){
					$product = wc_get_product($field['value']);
					echo '<h3>'.get_the_title($field['value']).'<span class="change_product">'.__('Change','wplms-front-end').'</span><span class="edit_product">'.__('Edit','wplms-front-end').'</span><strong class="price">'.$product->get_price_html().'</strong>
					<input type="hidden" id="product_id" class="post_field" data-id="vibe_product" value="'.$field['value'].'" /></h3>';
				}else{
					echo '<h3>'.$field['text'].'<span class="change_product">'.__('Set Product','wplms-front-end').'</span></h3>';
				}
				?>	

				<div id="change_product" class="field_wrapper" <?php if(empty($field['value'])){echo 'style="display:block;"';}else{echo 'style="display:none;"';} ?>>
				<a class="hide_parent"><i class="icon-x"></i></a>		
					<div class="col-md-6">
						<a class="more"><i class="icon-users"></i> <?php _e('Select existing product','vibe'); ?></a>
						<div class="select_product_form">
							<select class="selectcpt select2" data-cpt="product" data-placeholder="<?php _e('Search a product','vibe'); ?>">
							</select>
							<a class="use_selected_product button"><?php _e('Set Product','vibe'); ?></a>
						</div>
					</div>
					<div class="col-md-6">
						<a class="more"><i class="icon-user"></i> <?php _e('Create new product','vibe'); ?></a>
						<div class="new_product_form">
							<?php
								
								foreach($product_fields as $product_field){
									echo '<div class="vibe_'.$product_field['id'].' '.(empty($product_field['style'])?'':$product_field['style']).'">';
										unset($product_field['style']);
										self::generate_fields($product_field);
									echo '</div>';	
								}
							?>
							<a class="button small" id="create_new_product"><?php _e('Create Product','vibe'); ?></a>
						</div>
					</div>
				</div>
				<?php if(!empty($field['value'])){ ?>
				<div id="edit_product" class="field_wrapper">
					<a class="hide_parent"><i class="icon-x"></i></a>
					<?php
						foreach($product_fields as $product_field){
							echo '<div class="vibe_'.$product_field['id'].' '.(empty($product_field['style'])?'':$product_field['style']).'">';
								unset($product_field['style']);
								if($product_field['id'] == 'vibe_subscription'){
									$product_field['id'] = 'vibe_subscription1';
								}
								self::generate_fields($product_field,$field['value']);
							echo '</div>';	
						}
					?>
					<input type="hidden" class="post_field" data-id="ID" value="<?php echo $field['value']; ?>" />
					<a class="button small" id="edit_course_product"><?php _e('Edit Product','vibe'); ?></a>
				</div>
				<?php
				}
			break;
			case 'multiselect':
				echo '<label>'.$field['label'].(empty($field['desc'])?'':'<a class="tip" title="'.$field['desc'].'"><i class="icon-question"></i></a>').'</label><strong>'.$field['text'].'</strong>';
				echo '<select class="select2 post_field" data-id="'.$field['id'].'" style="width: 100%;" multiple>';
				if(!empty($field['options'])){
					foreach($field['options'] as $option){
						echo '<option value="'.$option['value'].'" '.(($field['value'] == $option['value'])?'selected="selected"':'').'>'.$option['label'].'</option>';
					}
				}
				echo '</select>';
			break;
			case 'selectmulticpt':
				echo '<div class="field_wrapper '. $field['style'].'">';
				echo '<label>'.$field['label'].(empty($field['desc'])?'':'<a class="tip" title="'.$field['desc'].'"><i class="icon-question"></i></a>').'</label>'.(!empty($field['text'])?'<strong>'.$field['text'].'</strong>':'');
				if(empty($field['post_status'])){
					$field['post_status'] = 'publish';
				}else{
					$field['post_status'] = implode(',',$field['post_status']);
				}
				echo (!empty($field['text'])?'<div class="right" style="width:240px">':'').'<select class="select2 selectcpt post_field" data-id="'.$field['id'].'" data-type="'.$field['type'].'" data-status="'.$field['post_status'].'" style="width: 100%;" data-placeholder="'.$field['placeholder'].'" data-cpt="'.(($field['cpt'])?$field['cpt']:(($field['post_type'])?$field['post_type']:'')).'" multiple>';
				if(!empty($field['value']) && $field['value'] != $field['default']){
					if(is_array($field['value'])){
						foreach($field['value'] as $value){
							echo '<option value="'.$value.'" selected="selected">'.get_the_title($value).'</option>';
						}
					}
				}
				echo '</select></div>';
			break;
			case 'course_live':
			?>
			<?php
            if(!empty($_GET['action'])){
                ?>
                    <strong class="heading"><?php _e('Modify Course','vibe'); ?> <span><a href="<?php echo get_permalink($_GET['action']); ?>"><?php _e('Back to course','vibe'); ?></a></span></strong>
                    <?php
                        if(get_post_type($_GET['action']) == 'course'){
                            $post_status = get_post_status($_GET['action']);   
                            if($post_status == 'publish'){
                            	echo '<a id="offline_course" class="button big hero">'.__('TAKE OFFLINE','vibe').'</a>'; 	
                            }else{
                        		$new_course_status = vibe_get_option('new_course_status');
                            	if(isset($new_course_status) && $new_course_status == 'publish')
	                                echo '<a id="publish_course" class="button big hero">'.__('GO LIVE','vibe').'</a>';
	                            else
	                                echo '<a id="publish_course" class="button big hero">'.__('SEND FOR APPROVAL','vibe').'</a>';
	                        }

                            $delete_enable = apply_filters('wplms_front_end_course_delete',0);
                            if($delete_enable){
                                echo '<hr /><a id="delete_course" class="button big full primary">'.__('DELETE COURSE','vibe').'</a>';
                                echo '<a class="link right showhide_indetails">'.__('SHOW OPTIONS','vibe').'</a>';
                                $delete_options = apply_filters('wplms_course_delete_options',array(
                                    'unit'=>array(
                                        'label'=>__('Delete Units','vibe'),
                                        'post_type'=>'unit',
                                        'post_meta'=>'vibe_course_curriculum'
                                        ),
                                    'quiz'=>array(
                                        'label'=>__('Delete Quizzes','vibe'),
                                        'post_type'=>'quiz',
                                        'post_meta'=>'vibe_course_curriculum'
                                        ),
                                    'assignment'=>array(
                                        'label'=>__('Delete Assignments','vibe'),
                                        'post_type'=>'wplms-assignment',
                                        'post_meta'=>'vibe_assignment_course'
                                        ),
                                    ));

                                echo '<div class="in_details"><ul class="clear">';
                                foreach($delete_options as $option){
                                    echo '<li><label>'.$option['label'].'</label><input class="delete_field right" type="checkbox" value="1" data-posttype="'.$option['post_type'].'"  data-meta="'.$option['post_meta'].'" /></li>';
                                }
                                echo '</ul></div>';
                            }
                        }else{
                    ?>
                    <?php   
                                echo '<p class="message">'.__('Course not set','vibe').'</p>';
                        }
                    ?>
                <?php
            }else{
                ?>
                    <strong class="heading"><?php _e('Go Live','vibe'); ?></strong>
                    <?php   $new_course_status = vibe_get_option('new_course_status');
                            if(isset($new_course_status) && $new_course_status == 'publish')
                                echo '<a id="publish_course" class="button big hero">'.__('GO LIVE','vibe').'</a>';
                            else
                                echo '<a id="publish_course" class="button big hero">'.__('SEND FOR APPROVAL','vibe').'</a>';
                    ?>
                <?php
            }
            ?>
			<?php
			break;
			case 'button':
				echo '<br class="clear" /><hr />';
				echo '<a id="'.$field['id'].'" class="button hero">'.$field['label'].'</a>';
			break;
			case 'small_button':
				echo '<a id="'.$field['id'].'" '.(empty($field['href'])?'':'href="'.$field['href'].'"').' '.(empty($field['data-id'])?'':'data-id="'.$field['data-id'].'"').' target="_blank" class="button">'.$field['label'].'</a>';
			break;
			case 'dynamic_taxonomy':
				echo '<label>'.$field['label'].(empty($field['desc'])?'':'<a class="tip" title="'.$field['desc'].'"><i class="icon-question"></i></a>').'</label>'.(empty($field['text'])?'':'<strong>'.$field['text'].'</strong>');
				echo '<select class="select2 post_field" data-id="'.$field['id'].'" data-type="array" style="width: 100%;" multiple>';
				$terms = get_terms( $field['taxonomy'], array('fields' => 'id=>name') );
				if(empty($field['value'])){
					$field['value'] = array();
				}
				if(!empty($terms) && is_array($terms)){
					foreach ($terms as $key=>$term ){
						echo '<option value="' . $key . '" '.(in_array($key,$field['value'])?'SELECTED':'').'>' . $term . '</option>';
					}
				}
				echo '</select>';
			break;
			case 'repeatable_selectcpt':
			               
			break;
			case 'repeatable_count':
				?>
	                <a class="button small primary add_repeatable_count_option"><?php _e('ADD OPTION','wplms-front-end'); ?></a>
	                <ul id="<?php echo $field['id']; ?>" data-id="<?php echo $field['id']; ?>" class="repeatable post_field">
	                    <?php

	                        if(isset($field['value']) && is_array($field['value'])){
	                            foreach($field['value'] as $key => $option){
	                                echo '<li><span>'.($key+1).'</span>
	                                			<input type="text" class="option very_large_box" value="'.$option.'" />
				                                <a class="rem"><i class="icon-x"></i></a>
	        	                        </li>';
	                            }
	                        }
	                    ?>
	                </ul>
	                <ul class="hidden">
	                    <li><span></span><input type="text" class="option very_large_box" /><a class="rem"><i class="icon-x"></i></a></li>
	                </ul>
				<?php
			break;
			case 'assignment':
				?>
				<?php
					if(!empty($field['value'])){
						foreach($field['value'] as $k=>$assignment_id){
							?>
							<div class="list-group-item assignment_block">
								<span class="dashicons dashicons-sort"></span>
								<strong class="title" data-id="<?php echo $assignment_id; ?>"><?php echo get_the_title($assignment_id); ?></strong>
								<input type="hidden" class="assignment_id" value="<?php echo $assignment_id; ?>" />
								<?php echo '<ul class="data_links">
                                    <li><a class="edit_sub" title="'.__('Edit','vibe').'"><span class="dashicons dashicons-edit"></span></a></li>
                                    <li><a class="preview_sub" title="'.__('Preview','vibe').'" target="_blank"><span class="dashicons dashicons-visibility"></span></a></li>
                                    <li><a class="remove_sub" title="'.__('Remove','vibe').'"><span class="dashicons dashicons-no-alt"></span></a></li>
                                    <li><a class="delete_sub" title="'.__('Delete','vibe').'"><span class="dashicons dashicons-trash"></span></a></li>
                                </ul>' ?>									
							</div>	
							<?php
						}
					}
				?>
				<div class="list-group-item hidden_block hide">
					<span class="dashicons dashicons-sort"></span>
					<strong class="title" data-id=""></strong>
					<input type="hidden" class="assignment_id" value="" />
					<?php echo '<ul class="data_links">
                                    <li><a class="edit_sub" title="'.__('Edit','vibe').'"><span class="dashicons dashicons-edit"></span></a></li>
                                    <li><a class="preview_sub" title="'.__('Preview','vibe').'" target="_blank"><span class="dashicons dashicons-visibility"></span></a></li>
                                    <li><a class="remove_sub" title="'.__('Remove','vibe').'"><span class="dashicons dashicons-no-alt"></span></a></li>
                                    <li><a class="delete_sub" title="'.__('Delete','vibe').'"><span class="dashicons dashicons-trash"></span></a></li>
                                </ul>' ?>							
				</div>
				<div class="list-group-item">
					<div class="add_cpt">
						<div class="col-md-6">
							<a class="more"><i class="icon-users"></i> <?php _e('Select existing assignment','vibe'); ?></a>
							<div class="select_existing_cpt">
								<select class="selectcpt select2" data-cpt="wplms-assignment" data-placeholder="<?php _e('Search an assignment','vibe'); ?>">
								</select>
								<a class="use_selected_assignment button"><?php _e('Set Assignment','vibe'); ?></a>
							</div>
						</div>
						<div class="col-md-6">
							<a class="more"><i class="icon-user"></i> <?php _e('Create new Assignment','vibe'); ?></a>
							<div class="new_cpt">
								<input type="text" class="form_field" id="vibe_assignment_title" name="name" placeholder="<?php _e('Reference title','vibe'); ?>">
								<a class="button small" id="create_new_assignment"><?php _e('Create Assignment','vibe'); ?></a>
							</div>
						</div>
					</div>
                </div>
				<?php			               	
				?>
				<?php
			break;
			case 'quiz_questions':
				?>
				<?php
					if(!empty($field['value'])){
						foreach($field['value']['ques'] as $k=>$question_id){
							?>
							<div class="list-group-item question_block">
								<span class="dashicons dashicons-sort"></span>
								<strong class="title" data-id="<?php echo $question_id; ?>"><?php echo get_the_title($question_id); ?></strong>
								<input type="hidden" class="question_id" value="<?php echo $question_id; ?>" />
								<?php echo '<ul class="data_links">
                                    <li><a class="edit_sub" title="'.__('Edit','vibe').'"><span class="dashicons dashicons-edit"></span></a></li>
                                    <li><a class="preview_sub" title="'.__('Preview','vibe').'" target="_blank"><span class="dashicons dashicons-visibility"></span></a></li>
                                    <li><a class="remove_sub" title="'.__('Remove','vibe').'"><span class="dashicons dashicons-no-alt"></span></a></li>
                                    <li><a class="delete_sub" title="'.__('Delete','vibe').'"><span class="dashicons dashicons-trash"></span></a></li>
                                </ul>' ?>
								<div class="right">
									<input type="number" class="small_box question_marks" value="<?php echo $field['value']['marks'][$k] ?>" />
									<span><?php _e('Marks','wplms-front-end'); ?></span>
								</div>									
							</div>	
							<?php
						}
					}
				?>
				<div class="list-group-item hidden_block hide">
					<span class="dashicons dashicons-sort"></span>
					<strong class="title" data-id=""></strong>
					<input type="hidden" class="question_id" value="" />
					<?php echo '<ul class="data_links">
                        <li><a class="edit_sub" title="'.__('Edit','vibe').'"><span class="dashicons dashicons-edit"></span></a></li>
                        <li><a class="preview_sub" title="'.__('Preview','vibe').'" target="_blank"><span class="dashicons dashicons-visibility"></span></a></li>
                        <li><a class="remove_sub" title="'.__('Remove','vibe').'"><span class="dashicons dashicons-no-alt"></span></a></li>
                        <li><a class="delete_sub" title="'.__('Delete','vibe').'"><span class="dashicons dashicons-trash"></span></a></li>
                    </ul>' ?>
					<div class="right">
						<input type="number" class="small_box question_marks" value="<?php echo $field['value']['marks'][$k] ?>" />
						<span><?php _e('Marks','wplms-front-end'); ?></span>
					</div>									
				</div>
				<div class="list-group-item">
					<div class="add_cpt">
						<div class="col-md-6">
							<a class="more"><i class="icon-users"></i> <?php _e('Select existing question','vibe'); ?></a>
							<div class="select_existing_cpt">
								<select class="selectcpt select2" data-cpt="question" data-placeholder="<?php _e('Search a question','vibe'); ?>">
								</select>
								<a class="use_selected_question button"><?php _e('Set Question','vibe'); ?></a>
							</div>
						</div>
						<div class="col-md-6">
							<a class="more"><i class="icon-user"></i> <?php _e('Create new Question','vibe'); ?></a>
							<div class="new_cpt">
								<input type="text" class="form_field" id="vibe_question_title" name="name" placeholder="<?php _e('Reference title','vibe'); ?>">
								<?php
									$field = array(
											'label'=> __('Question Tags','vibe'),
											'type'=> 'taxonomy',
											'taxonomy'=> 'question-tag',
											'from'=>'taxonomy',
											'value_type'=>'single',
											'style'=>'',
											'id' => 'question-tag',
											'default'=> __('Select a Tag','vibe'),
										);
									self::generate_fields($field);
								?>
								<?php
								$question_types = apply_filters('wplms_question_types',array(
						              array( 'label' =>__('True or False','vibe-customtypes'),'value'=>'truefalse'),  
						              array( 'label' =>__('Multiple Choice','vibe-customtypes'),'value'=>'single'),
						              array( 'label' =>__('Multiple Correct','vibe-customtypes'),'value'=>'multiple'),
						              array( 'label' =>__('Sort Answers','vibe-customtypes'),'value'=>'sort'),
						              array( 'label' =>__('Match Answers','vibe-customtypes'),'value'=>'match'),
						              array( 'label' =>__('Fill in the Blank','vibe-customtypes'),'value'=>'fillblank'),
						              array( 'label' =>__('Dropdown Select','vibe-customtypes'),'value'=>'select'),
						              array( 'label' =>__('Small Text','vibe-customtypes'),'value'=>'smalltext'),
						              array( 'label' =>__('Large Text','vibe-customtypes'),'value'=>'largetext')
						            ));
								?>
								<select class="chosen" id="vibe_question_template">
								<?php
									foreach($question_types as $type){
										echo '<option value="'.$type['value'].'">'.$type['label'].'</option>';
									}
								?>
								</select>
								<a class="button small" id="create_new_question"><?php _e('Create question','vibe'); ?></a>
							</div>
						</div>
					</div>
                </div>
				<?php			               	
				?>
				<?php
			break;
			case 'curriculum':
			?>
                <ul class="curriculum post_field">
                <?php 
                if(isset($_GET['action'])){
                    $curriculum = vibe_sanitize(get_post_meta($_GET['action'],'vibe_course_curriculum',false));
                   
                    if(isset($curriculum) && is_array($curriculum)){
                        foreach($curriculum as $kid){
                            if(is_numeric($kid)){
                                if(get_post_type($kid) == 'unit'){
                                    echo '<li><strong class="title" data-id="'.$kid.'"><i class="icon-file"></i> '.get_the_title($kid).'</strong>
                                            <ul class="data_links">
                                                <li><a class="edit" title="'.__('Edit Unit','vibe').'"><span class="dashicons dashicons-edit"></span></a></li>
                                                <li><a class="preview" title="'.__('Preview','vibe').'" target="_blank"><span class="dashicons dashicons-visibility"></span></a></li>
                                                <li><a class="remove" title="'.__('Remove','vibe').'"><span class="dashicons dashicons-no-alt"></span></a></li>
                                                <li><a class="delete" title="'.__('Delete','vibe').'"><span class="dashicons dashicons-trash"></span></a></li>
                                            </ul>
                                        </li>';
                                }else{
                                    echo '<li><strong class="title" data-id="'.$kid.'"><i class="icon-task"></i> '.get_the_title($kid).'</strong>
                                            <ul class="data_links">
                                                <li><a class="edit" title="'.__('Edit Quiz','vibe').'"><span class="dashicons dashicons-edit"></span></a></li>
                                                <li><a class="preview" title="'.__('Preview','vibe').'" target="_blank"><span class="dashicons dashicons-visibility"></span></a></li>
                                                <li><a class="remove" title="'.__('Remove','vibe').'"><span class="dashicons dashicons-no-alt"></span></a></li>
                                                <li><a class="delete" title="'.__('Delete','vibe').'"><span class="dashicons dashicons-trash"></span></a></li>
                                            </ul>
                                          </li>';
                                }
                            }else{
                                echo '<li class="new_section"><strong>'.$kid.'</strong>
		                                <ul class="data_links">
		                                	<li>
		                                		<a class="remove" title="'.__('Remove','vibe').'"><span class="dashicons dashicons-no-alt"></span></a>
		                                	</li>
		                                </ul>
		                            </li>';
                            }
                        }
                    }
                }
                ?>
                </ul>
                <ul class="hide">
					<li><strong class="title" data-id=""><i class="icon-task"></i> <span></span></strong>
                        <ul class="data_links">
                            <li><a class="edit" title="<?php _e('Edit Quiz','vibe'); ?>"><span class="dashicons dashicons-edit"></span></a></li>
                            <li><a class="preview" title="<?php _e('Preview','vibe'); ?>" target="_blank"><span class="dashicons dashicons-visibility"></span></a></li>
                            <li><a class="remove" title="<?php _e('Remove','vibe'); ?>"><span class="dashicons dashicons-no-alt"></span></a></li>
                            <li><a class="delete" title="<?php _e('Delete','vibe'); ?>"><span class="dashicons dashicons-trash"></span></a></li>
                        </ul>
                    </li>
				</ul>
                <ul id="hidden_base">
                    <li class="new_section">
                        <input type="text" class="section " placeholder="<?php _e('Enter Section Title','wplms-front-end'); ?>" />
                        <a class="rem"><i class="icon-x"></i></a>
                    </li>
                    <li class="new_unit">
                    	<div class="add_cpt">
							<div class="col-md-6">
								<a class="more"><i class="icon-users"></i> <?php _e('Select existing unit','vibe'); ?></a>
								<div class="select_existing_cpt">
									<select data-cpt="unit" data-placeholder="<?php _e('Search a unit','vibe'); ?>">
									</select>
									<a class="use_selected_curriculum button"><?php _e('Set Unit','vibe'); ?></a>
								</div>
							</div>
							<div class="col-md-6">
								<a class="more"><i class="icon-user"></i> <?php _e('Create new unit','vibe'); ?></a>
								<div class="new_cpt">
									<input type="text" class="form_field vibe_curriculum_title" name="name" placeholder="<?php _e('Unit title','vibe'); ?>">
									<input type="hidden" class="vibe_cpt" value="unit" />
									
									<a class="button small create_new_curriculum"><?php _e('Create Unit','vibe'); ?></a>
								</div>
							</div>
						</div>	
						<a class="rem"><i class="icon-x"></i></a>
                    </li>
                    <li class="new_quiz">
                    	<div class="add_cpt">
							<div class="col-md-6">
								<a class="more"><i class="icon-users"></i> <?php _e('Select existing quiz','vibe'); ?></a>
								<div class="select_existing_cpt">
									<select data-cpt="quiz" data-placeholder="<?php _e('Search a quiz','vibe'); ?>">
									</select>
									<a class="use_selected_curriculum button"><?php _e('Set Quiz','vibe'); ?></a>
								</div>
							</div>
							<div class="col-md-6">
								<a class="more"><i class="icon-user"></i> <?php _e('Create new quiz','vibe'); ?></a>
								<div class="new_cpt">
									<input type="text" class="form_field vibe_curriculum_title" name="name" placeholder="<?php _e('Quiz title','vibe'); ?>">
									<input type="hidden" class="vibe_cpt" value="quiz" />
									<a class="button small create_new_curriculum"><?php _e('Create Quiz','vibe'); ?></a>
								</div>
							</div>
						</div>
						<a class="rem"><i class="icon-x"></i></a> 
                    </li>
                </ul>
                <div class="add_element">
                	<?php
                		foreach($field['buttons'] as $key => $label){
							echo '<a id="'.$key.'" class="button primary">'.$label.'</a>';
						}
                	?>
                </div>
                <a id="save_course_curriculum_button" class="button hero"><?php _e('SAVE CURRICULUM','vibe'); ?></a>
			<?php
			break;
		}

	}

	function active_components_check($tabs){

		if(!function_exists('bp_is_active') || !bp_is_active('groups')){
			unset($tabs['course_components']['fields'][0]);
		}
		if ( !in_array( 'bbpress/bbpress.php', apply_filters( 'active_plugins', get_option( 'active_plugins' ) ) ) ) {
			unset($tabs['course_components']['fields'][1]);
		}
		if(count($tabs['course_components']['fields']) <2){
			unset($tabs['course_components']);
		}
		$level = vibe_get_option('level');
		if(!empty($level)){
			$levels[] = array(
							'label'=> __('Course Level','vibe'),
							'type'=> 'taxonomy',
							'taxonomy'=> 'level',
							'from'=>'taxonomy',
							'value_type'=>'single',
							'style'=>'col-md-12',
							'id' => 'level',
							'default'=> __('Select a Course Level','vibe'),
							);
			array_splice( $tabs['create_course']['fields'],2, 0, $levels );
		}
		$location = vibe_get_option('location');
		if(!empty($location)){
			$locations[] = array(
							'label'=> __('Course Location','vibe'),
							'type'=> 'taxonomy',
							'taxonomy'=> 'location',
							'from'=>'taxonomy',
							'value_type'=>'single',
							'style'=>'col-md-12',
							'id' => 'location',
							'default'=> __('Select a Course location','vibe'),
							);
			array_splice( $tabs['create_course']['fields'],2, 0, $locations );
		}
		return $tabs;
	}

	function get_group_name($group_id){
		global $wpdb,$bp;
		$name = $wpdb->get_var($wpdb->prepare("SELECT name from {$bp->groups->table_name} WHERE id = %d",$group_id));
		return $name;
	}
}


add_shortcode('edit_course','wplms_edit_course_shortcode');

function wplms_edit_course_shortcode(){
	
	$fields = WPLMS_Front_End_Fields::init();

	if(isset($_GET['action']) && is_numeric($_GET['action']) && get_post_type($_GET['action']) == 'course'){
		$fields->course_id = $_GET['action'];
	}
	do_action('wplms_before_create_course_header');
	$fields->create_tabs();
	$fields->course_tab_module();

}